package com.eactive.eai.batch.job.jobItem.bokgg;

import java.io.ByteArrayOutputStream;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.osd.OutsideManager;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_BOKGG_0600 extends DefaultTelegram implements TelegramService {

    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

    //>> 업무관리정보
    private final String OpCode_start          = "001";    //개별 업무 개시
    //private final String OpCode_unit_end       = "003";    //개별업무 종료
    private final String OpCode_all_end        = "004";    //개별업무 종료

    private Properties telegramInfo;

    /**
     * 생성자
     */
    public SEND_BOKGG_0600() {
        //업무개시요구 및 업무개시통보
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
            boolean result = calculateSendLength();
            if (!result) return false;
            if ( OpCode_start.equals(getFldOpCode()) ) {
                if (!setIdPass()) return false;
            }

            //전문송신 Byte 수
            compileField(0, ""+SEND_LENGTH, this.al_FieldProps[0]);

            //업무구분코드 - BOK
            compileField(1, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[1]);

            //기관코드 - 지로코드
            compileField(2, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[2]);

            //전문종별코드.
            compileField(3, this.getFldTelegramType(), this.al_FieldProps[3]);

            //거래구분코드
            compileField(4, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[4]);

            //송수신 FLAG : 전문발생 주체, 항시 ‘B'
            compileField(5, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_BANK), this.al_FieldProps[5]);

            //응답코드
            compileField(6, TelegramKeys.BOKGG_RES_CODE_SUCESS, this.al_FieldProps[6]);
            // 여기 까지 공통부

            //송수신 업무 구분코드.- BOK 중심 수신 구분, 항시 ‘S'
            compileField(7, getFldTrClass() , this.al_FieldProps[7]);

            //전문 전송일시 YYYYMMDDHHMMSS     기관에서 수신 시간 이후에  미수신자료를 수신코자 할 때는 전송일자와 상수(YYYYMMDD999999)를 SET한다.
            compileField(8, TelegramKeys.getYYYYMMddHHmmss().substring(0,12), this.al_FieldProps[8]);

            //업무 관리 정보 - 파일전송업무 관리를 위한 정보로 아래의 값 중 하나를 Set 한다.
            // “001”: 개별 업무 개시  “003”: 개별 업무 종료 “004”: 전업무종료 요구/요구응답
            compileField(9, this.getFldOpCode(), this.al_FieldProps[9]);

            //송신자명 파일전송업무의 책임이 있는 사람의 나타내는 ID를 Set한다.
            compileField(10, batchDoc.getBatchMsg().getHeader().getUserID(), this.al_FieldProps[10]);

            //송신자 암호 (정당한 송신자 확인을 위한 쌍방간 합의된 암호
            compileField(11, batchDoc.getBatchMsg().getHeader().getUserPassword(), this.al_FieldProps[11]);

            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;

        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<7; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=7; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    private boolean calculateSendLength () {
        try {
            for (int i=1; i< this.al_Field.size() - 1; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH += this.getCalculatedLength(this.al_Field.size() - 1);
            REAL_SEND_LENGTH = SEND_LENGTH;
            for (int i=0; i < 1 ; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                REAL_SEND_LENGTH += aField.length;
            }
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    public int getInformalFieldSendData(int idx, byte[] data) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < 8) {
                logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                String[] msgArgs = new String[1];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if ( !OpCode_all_end.equals(getFldOpCode()) ) {
                return 0;
            }
            String summary = "01" + batchDoc.getBatchMsg().getHeader().getBizCode();
            System.arraycopy( summary.getBytes(), 0, data, 0, 8);
            return 8;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }

    /**
     * 비정형 필드에 대한 송신 길이를 계산해서 리턴해준다.
     *
     * 필드(idx)가 비정형 필드(XX)인지 점검하고 , 해당 필드에 대한 예상 길이를 계산하여 리턴하도록 한다
     *
     * 비정형 필드를 가지고 있는 개별 Telegram Class 에서 오버라이드 필요.
     */
    public int getCalculatedLength(int idx) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
                if ( !OpCode_all_end.equals(getFldOpCode()) ) {
                    return 0;
                }
                else return 8;
            } else {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI012";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
        }catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI005";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    private boolean setIdPass(){
        try {
        	String hdrInfo   = batchDoc.getBatchMsg().getHeader().getHdrInfoName();
            String procCode  = batchDoc.getBatchMsg().getHeader().getProcessCode();
            String instiCode = batchDoc.getBatchMsg().getHeader().getInstitutionCode();
            String userID    = hdrInfo.substring(38,58);
            String passWord  = hdrInfo.substring(58,66);
            batchDoc.getBatchMsg().getHeader().setUserID(userID);
            batchDoc.getBatchMsg().getHeader().setUserPassword(passWord);
            try {
                OutsideManager.getInstance().updateOsdIdPassword(procCode, instiCode, userID, passWord);
            } catch (Exception e) {
                logger.warn("ID와 비밀번호 수정 실패");
                logger.error( e.getMessage(), e);
            }
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(3);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(7);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(6);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getFieldValueString(9);
    }
}
